#include <amxmodx>
#include <reapi>
#include <vip_system>

#pragma semicolon 1
new const VIP_MDL_TT[] = "vip_t";		//	model name
new const VIP_MDL_CT[] = "vip_ct";	//	model name

public plugin_precache() {
	new szMdl[64];
	formatex(szMdl, charsmax(szMdl), "models/player/%s/%s.mdl", VIP_MDL_TT, VIP_MDL_TT);
	precache_model(szMdl);
	formatex(szMdl, charsmax(szMdl), "models/player/%s/%s.mdl", VIP_MDL_CT, VIP_MDL_CT);
	precache_model(szMdl);
}

public plugin_init()
	register_plugin("[ReVIP] Model", VIP_SYSTEM_VERSION, "pUzzlik");

public vip_core_player_spawn(const id) {
	if(get_flag_access(id)) {
		if(!is_user_alive(id)) {
			rg_reset_user_model(id);
			return;
		}
		
		new TeamName:team = get_member(id, m_iTeam);
		switch(team) {
			case TEAM_TERRORIST: rg_set_user_model(id, VIP_MDL_TT);
			case TEAM_CT: rg_set_user_model(id, VIP_MDL_CT);
		}
		return;
	}
}