#include <amxmodx>
#include <reapi>
#include <vip_system>

#pragma semicolon 1

new g_iRoundCount[MAX_CLIENTS+1];
new pCvarResetBlock, g_iRoundBlock;

public plugin_init() {
	register_plugin("[ReVIP] Reset Score", VIP_SYSTEM_VERSION, "pUzzlik");
	register_dictionary("vip_system.txt");
	
	pCvarResetBlock = register_cvar("rs_block_rnd","");

	register_clcmd("say /rs","ResetScore");
	register_clcmd("say /resetscore","ResetScore");
	register_clcmd("say_team /rs","ResetScore");
	register_clcmd("say_team /resetscore","ResetScore");
}

public plugin_cfg() g_iRoundBlock = get_pcvar_num(pCvarResetBlock);

public vip_core_player_spawn(const id)
	if(g_iRoundCount[id] > 0) g_iRoundCount[id]--;

public ResetScore(const id) {
	if(!is_user_connected(id)) return;
	if(g_iRoundCount[id] > 0) {
		if(!get_flag_access_def(id)) client_print_color(id, -2, "%L %L", LANG_SERVER, "RS_TAG", LANG_SERVER, "RESET_BLOCK", g_iRoundCount[id]);
		else client_print_color(id, -2, "%L %L", LANG_SERVER, "RS_TAG", LANG_SERVER, "RESET_BLOCK_VIP", g_iRoundCount[id]);
		return;
	}
	client_cmd(id, "spk buttons/blip1.wav");

	set_entvar(id, var_frags, 0.0); set_member(id, m_iDeaths, 0);
	client_print_color(id, 0, "%L %L", LANG_SERVER, "RS_TAG", LANG_SERVER, "RESET_SCORE"); 

	static mScoreInfo; if(!mScoreInfo) mScoreInfo = get_user_msgid("ScoreInfo");
	message_begin(MSG_ALL, mScoreInfo);
	write_byte(id);
	write_short(0);
	write_short(0);
	write_short(0);
	write_short(get_member(id, m_iTeam));
	message_end();
	
	if(get_flag_access_def(id)) g_iRoundCount[id] = 1;
	else g_iRoundCount[id] = g_iRoundBlock;
}